// FoodFill.h

#ifndef FLOOD_FILL_H
#define FLOOD_FILL_H

#include "Globals.h"
#include "VoxIndex.h"
#include <vector>

using std::vector;



class FloodFill {

public:
  FloodFill();
  ~FloodFill();
  
  static void floodFillStack(short x, short y, short z, float& tColor, float& rColor);
  static void floodFillQueue(short x, short y, short z, float tColor, float rColor);

private:
  static bool colorsAreEqual(float col1, float col2);
  static void floodFillQueueHelper(short x, short y, short z, vector<VoxIndex>& queue, float& tColor, float& rColor);
  static VoxIndex findFirstValidVoxel();
  static void placeSeed();

};

#endif // FLOOD_FILL_H
