
#include "MarchingCubes.h"
#include "Voxel.h"
#include "Triangle.h"


MarchingCubes::MarchingCubes()
{
  //voxels = v;
}

MarchingCubes::~MarchingCubes() {}

/*
void MarchingCubes::testFunc()
{
  blaa = GRID_SIZE;
  cout << "Grid size: " << GRID_SIZE;
}
*/


// configuration 1 starts here
bool MarchingCubes::cubeState0(short& x, short& y, short& z)
{
  return voxels[x][y][z] == NULL &&
    voxels[x+1][y][z] == NULL &&
    voxels[x+1][y+1][z] == NULL &&
    voxels[x][y+1][z] == NULL &&
    voxels[x][y][z+1] == NULL &&
    voxels[x+1][y][z+1] == NULL &&
    voxels[x+1][y+1][z+1] == NULL &&
    voxels[x][y+1][z+1] == NULL;
}

// configuration 2 starts here
bool MarchingCubes::cubeState1(short& x, short& y, short& z)
{
  return voxels[x][y][z] != NULL &&
    voxels[x+1][y][z] == NULL &&
    voxels[x+1][y+1][z] == NULL &&
    voxels[x][y+1][z] == NULL &&
    voxels[x][y][z+1] == NULL &&
    voxels[x+1][y][z+1] == NULL &&
    voxels[x+1][y+1][z+1] == NULL &&
    voxels[x][y+1][z+1] == NULL;
}

bool MarchingCubes::cubeState2(short& x, short& y, short& z)
{
  return voxels[x][y][z] == NULL &&
    voxels[x+1][y][z] != NULL &&
    voxels[x+1][y+1][z] == NULL &&
    voxels[x][y+1][z] == NULL &&
    voxels[x][y][z+1] == NULL &&
    voxels[x+1][y][z+1] == NULL &&
    voxels[x+1][y+1][z+1] == NULL &&
    voxels[x][y+1][z+1] == NULL;
}

bool MarchingCubes::cubeState3(short& x, short& y, short& z)
{
  return voxels[x][y][z] == NULL &&
    voxels[x+1][y][z] == NULL &&
    voxels[x+1][y+1][z] != NULL &&
    voxels[x][y+1][z] == NULL &&
    voxels[x][y][z+1] == NULL &&
    voxels[x+1][y][z+1] == NULL &&
    voxels[x+1][y+1][z+1] == NULL &&
    voxels[x][y+1][z+1] == NULL;
}

bool MarchingCubes::cubeState4(short& x, short& y, short& z)
{
  return voxels[x][y][z] == NULL &&
    voxels[x+1][y][z] == NULL &&
    voxels[x+1][y+1][z] == NULL &&
    voxels[x][y+1][z] != NULL &&
    voxels[x][y][z+1] == NULL &&
    voxels[x+1][y][z+1] == NULL &&
    voxels[x+1][y+1][z+1] == NULL &&
    voxels[x][y+1][z+1] == NULL;
}

bool MarchingCubes::cubeState5(short& x, short& y, short& z)
{
  return voxels[x][y][z] == NULL &&
    voxels[x+1][y][z] == NULL &&
    voxels[x+1][y+1][z] == NULL &&
    voxels[x][y+1][z] == NULL &&
    voxels[x][y][z+1] != NULL &&
    voxels[x+1][y][z+1] == NULL &&
    voxels[x+1][y+1][z+1] == NULL &&
    voxels[x][y+1][z+1] == NULL;
}

bool MarchingCubes::cubeState6(short& x, short& y, short& z)
{
  return voxels[x][y][z] == NULL &&
    voxels[x+1][y][z] == NULL &&
    voxels[x+1][y+1][z] == NULL &&
    voxels[x][y+1][z] == NULL &&
    voxels[x][y][z+1] == NULL &&
    voxels[x+1][y][z+1] != NULL &&
    voxels[x+1][y+1][z+1] == NULL &&
    voxels[x][y+1][z+1] == NULL;
}

bool MarchingCubes::cubeState7(short& x, short& y, short& z)
{
  return voxels[x][y][z] == NULL &&
    voxels[x+1][y][z] == NULL &&
    voxels[x+1][y+1][z] == NULL &&
    voxels[x][y+1][z] == NULL &&
    voxels[x][y][z+1] == NULL &&
    voxels[x+1][y][z+1] == NULL &&
    voxels[x+1][y+1][z+1] != NULL &&
    voxels[x][y+1][z+1] == NULL;
}

bool MarchingCubes::cubeState8(short& x, short& y, short& z)
{
  return voxels[x][y][z] == NULL &&
    voxels[x+1][y][z] == NULL &&
    voxels[x+1][y+1][z] == NULL &&
    voxels[x][y+1][z] == NULL &&
    voxels[x][y][z+1] == NULL &&
    voxels[x+1][y][z+1] == NULL &&
    voxels[x+1][y+1][z+1] == NULL &&
    voxels[x][y+1][z+1] != NULL;
}

// configuration 3 starts here
bool MarchingCubes::cubeState9(short& x, short& y, short& z)
{
  return voxels[x][y][z] != NULL &&
    voxels[x+1][y][z] != NULL &&
    voxels[x+1][y+1][z] == NULL &&
    voxels[x][y+1][z] == NULL &&
    voxels[x][y][z+1] == NULL &&
    voxels[x+1][y][z+1] == NULL &&
    voxels[x+1][y+1][z+1] == NULL &&
    voxels[x][y+1][z+1] == NULL;
}

bool MarchingCubes::cubeState10(short& x, short& y, short& z)
{
  return voxels[x][y][z] == NULL &&
    voxels[x+1][y][z] == NULL &&
    voxels[x+1][y+1][z] != NULL &&
    voxels[x][y+1][z] != NULL &&
    voxels[x][y][z+1] == NULL &&
    voxels[x+1][y][z+1] == NULL &&
    voxels[x+1][y+1][z+1] == NULL &&
    voxels[x][y+1][z+1] == NULL;
}

bool MarchingCubes::cubeState11(short& x, short& y, short& z)
{
  return voxels[x][y][z] == NULL &&
    voxels[x+1][y][z] == NULL &&
    voxels[x+1][y+1][z] == NULL &&
    voxels[x][y+1][z] == NULL &&
    voxels[x][y][z+1] != NULL &&
    voxels[x+1][y][z+1] != NULL &&
    voxels[x+1][y+1][z+1] == NULL &&
    voxels[x][y+1][z+1] == NULL;
}

bool MarchingCubes::cubeState12(short& x, short& y, short& z)
{
  return voxels[x][y][z] == NULL &&
    voxels[x+1][y][z] == NULL &&
    voxels[x+1][y+1][z] == NULL &&
    voxels[x][y+1][z] == NULL &&
    voxels[x][y][z+1] == NULL &&
    voxels[x+1][y][z+1] == NULL &&
    voxels[x+1][y+1][z+1] != NULL &&
    voxels[x][y+1][z+1] != NULL;
}

bool MarchingCubes::cubeState13(short& x, short& y, short& z)
{
  return voxels[x][y][z] != NULL &&
    voxels[x+1][y][z] == NULL &&
    voxels[x+1][y+1][z] == NULL &&
    voxels[x][y+1][z] == NULL &&
    voxels[x][y][z+1] != NULL &&
    voxels[x+1][y][z+1] == NULL &&
    voxels[x+1][y+1][z+1] == NULL &&
    voxels[x][y+1][z+1] == NULL;
}

bool MarchingCubes::cubeState14(short& x, short& y, short& z)
{
  return voxels[x][y][z] == NULL &&
    voxels[x+1][y][z] != NULL &&
    voxels[x+1][y+1][z] == NULL &&
    voxels[x][y+1][z] == NULL &&
    voxels[x][y][z+1] == NULL &&
    voxels[x+1][y][z+1] != NULL &&
    voxels[x+1][y+1][z+1] == NULL &&
    voxels[x][y+1][z+1] == NULL;
}

bool MarchingCubes::cubeState15(short& x, short& y, short& z)
{
  return voxels[x][y][z] == NULL &&
    voxels[x+1][y][z] == NULL &&
    voxels[x+1][y+1][z] != NULL &&
    voxels[x][y+1][z] == NULL &&
    voxels[x][y][z+1] == NULL &&
    voxels[x+1][y][z+1] == NULL &&
    voxels[x+1][y+1][z+1] != NULL &&
    voxels[x][y+1][z+1] == NULL;
}

bool MarchingCubes::cubeState16(short& x, short& y, short& z)
{
  return voxels[x][y][z] == NULL &&
    voxels[x+1][y][z] == NULL &&
    voxels[x+1][y+1][z] == NULL &&
    voxels[x][y+1][z] != NULL &&
    voxels[x][y][z+1] == NULL &&
    voxels[x+1][y][z+1] == NULL &&
    voxels[x+1][y+1][z+1] == NULL &&
    voxels[x][y+1][z+1] != NULL;
}

bool MarchingCubes::cubeState17(short& x, short& y, short& z)
{
  return voxels[x][y][z] != NULL &&
    voxels[x+1][y][z] == NULL &&
    voxels[x+1][y+1][z] == NULL &&
    voxels[x][y+1][z] != NULL &&
    voxels[x][y][z+1] == NULL &&
    voxels[x+1][y][z+1] == NULL &&
    voxels[x+1][y+1][z+1] == NULL &&
    voxels[x][y+1][z+1] == NULL;
}

bool MarchingCubes::cubeState18(short& x, short& y, short& z)
{
  return voxels[x][y][z] == NULL &&
    voxels[x+1][y][z] != NULL &&
    voxels[x+1][y+1][z] != NULL &&
    voxels[x][y+1][z] == NULL &&
    voxels[x][y][z+1] == NULL &&
    voxels[x+1][y][z+1] == NULL &&
    voxels[x+1][y+1][z+1] == NULL &&
    voxels[x][y+1][z+1] == NULL;
}

bool MarchingCubes::cubeState19(short& x, short& y, short& z)
{
  return voxels[x][y][z] == NULL &&
    voxels[x+1][y][z] == NULL &&
    voxels[x+1][y+1][z] == NULL &&
    voxels[x][y+1][z] == NULL &&
    voxels[x][y][z+1] == NULL &&
    voxels[x+1][y][z+1] != NULL &&
    voxels[x+1][y+1][z+1] != NULL &&
    voxels[x][y+1][z+1] == NULL;
}

bool MarchingCubes::cubeState20(short& x, short& y, short& z)
{
  return voxels[x][y][z] == NULL &&
    voxels[x+1][y][z] == NULL &&
    voxels[x+1][y+1][z] == NULL &&
    voxels[x][y+1][z] == NULL &&
    voxels[x][y][z+1] != NULL &&
    voxels[x+1][y][z+1] == NULL &&
    voxels[x+1][y+1][z+1] == NULL &&
    voxels[x][y+1][z+1] != NULL;
}

// configuration 4 starts here
bool MarchingCubes::cubeState21(short& x, short& y, short& z)
{
  return voxels[x][y][z] != NULL &&
    voxels[x+1][y][z] == NULL &&
    voxels[x+1][y+1][z] != NULL &&
    voxels[x][y+1][z] == NULL &&
    voxels[x][y][z+1] == NULL &&
    voxels[x+1][y][z+1] == NULL &&
    voxels[x+1][y+1][z+1] == NULL &&
    voxels[x][y+1][z+1] == NULL;
}

bool MarchingCubes::cubeState22(short& x, short& y, short& z)
{
  return voxels[x][y][z] == NULL &&
    voxels[x+1][y][z] != NULL &&
    voxels[x+1][y+1][z] == NULL &&
    voxels[x][y+1][z] != NULL &&
    voxels[x][y][z+1] == NULL &&
    voxels[x+1][y][z+1] == NULL &&
    voxels[x+1][y+1][z+1] == NULL &&
    voxels[x][y+1][z+1] == NULL;
}

bool MarchingCubes::cubeState23(short& x, short& y, short& z)
{
  return voxels[x][y][z] == NULL &&
    voxels[x+1][y][z] != NULL &&
    voxels[x+1][y+1][z] == NULL &&
    voxels[x][y+1][z] == NULL &&
    voxels[x][y][z+1] == NULL &&
    voxels[x+1][y][z+1] == NULL &&
    voxels[x+1][y+1][z+1] != NULL &&
    voxels[x][y+1][z+1] == NULL;
}

bool MarchingCubes::cubeState24(short& x, short& y, short& z)
{
  return voxels[x][y][z] == NULL &&
    voxels[x+1][y][z] == NULL &&
    voxels[x+1][y+1][z] != NULL &&
    voxels[x][y+1][z] == NULL &&
    voxels[x][y][z+1] == NULL &&
    voxels[x+1][y][z+1] != NULL &&
    voxels[x+1][y+1][z+1] == NULL &&
    voxels[x][y+1][z+1] == NULL;
}

bool MarchingCubes::cubeState25(short& x, short& y, short& z)
{
  return voxels[x][y][z] == NULL &&
    voxels[x+1][y][z] == NULL &&
    voxels[x+1][y+1][z] == NULL &&
    voxels[x][y+1][z] == NULL &&
    voxels[x][y][z+1] != NULL &&
    voxels[x+1][y][z+1] == NULL &&
    voxels[x+1][y+1][z+1] != NULL &&
    voxels[x][y+1][z+1] == NULL;
}

bool MarchingCubes::cubeState26(short& x, short& y, short& z)
{
  return voxels[x][y][z] == NULL &&
    voxels[x+1][y][z] == NULL &&
    voxels[x+1][y+1][z] == NULL &&
    voxels[x][y+1][z] == NULL &&
    voxels[x][y][z+1] == NULL &&
    voxels[x+1][y][z+1] != NULL &&
    voxels[x+1][y+1][z+1] == NULL &&
    voxels[x][y+1][z+1] != NULL;
}

bool MarchingCubes::cubeState27(short& x, short& y, short& z)
{
  return voxels[x][y][z] == NULL &&
    voxels[x+1][y][z] == NULL &&
    voxels[x+1][y+1][z] == NULL &&
    voxels[x][y+1][z] != NULL &&
    voxels[x][y][z+1] != NULL &&
    voxels[x+1][y][z+1] == NULL &&
    voxels[x+1][y+1][z+1] == NULL &&
    voxels[x][y+1][z+1] == NULL;
}

bool MarchingCubes::cubeState28(short& x, short& y, short& z)
{
  return voxels[x][y][z] != NULL &&
    voxels[x+1][y][z] == NULL &&
    voxels[x+1][y+1][z] == NULL &&
    voxels[x][y+1][z] == NULL &&
    voxels[x][y][z+1] == NULL &&
    voxels[x+1][y][z+1] == NULL &&
    voxels[x+1][y+1][z+1] == NULL &&
    voxels[x][y+1][z+1] != NULL;
}

bool MarchingCubes::cubeState29(short& x, short& y, short& z)
{
  return voxels[x][y][z] == NULL &&
    voxels[x+1][y][z] == NULL &&
    voxels[x+1][y+1][z] == NULL &&
    voxels[x][y+1][z] != NULL &&
    voxels[x][y][z+1] == NULL &&
    voxels[x+1][y][z+1] == NULL &&
    voxels[x+1][y+1][z+1] != NULL &&
    voxels[x][y+1][z+1] == NULL;
}

bool MarchingCubes::cubeState30(short& x, short& y, short& z)
{
  return voxels[x][y][z] == NULL &&
    voxels[x+1][y][z] == NULL &&
    voxels[x+1][y+1][z] != NULL &&
    voxels[x][y+1][z] == NULL &&
    voxels[x][y][z+1] == NULL &&
    voxels[x+1][y][z+1] == NULL &&
    voxels[x+1][y+1][z+1] == NULL &&
    voxels[x][y+1][z+1] != NULL;
}

bool MarchingCubes::cubeState31(short& x, short& y, short& z)
{
  return voxels[x][y][z] != NULL &&
    voxels[x+1][y][z] == NULL &&
    voxels[x+1][y+1][z] == NULL &&
    voxels[x][y+1][z] == NULL &&
    voxels[x][y][z+1] == NULL &&
    voxels[x+1][y][z+1] != NULL &&
    voxels[x+1][y+1][z+1] == NULL &&
    voxels[x][y+1][z+1] == NULL;
}

bool MarchingCubes::cubeState32(short& x, short& y, short& z)
{
  return voxels[x][y][z] == NULL &&
    voxels[x+1][y][z] != NULL &&
    voxels[x+1][y+1][z] == NULL &&
    voxels[x][y+1][z] == NULL &&
    voxels[x][y][z+1] != NULL &&
    voxels[x+1][y][z+1] == NULL &&
    voxels[x+1][y+1][z+1] == NULL &&
    voxels[x][y+1][z+1] == NULL;
}

// configuration 5 starts here
bool MarchingCubes::cubeState33(short& x, short& y, short& z)
{
  return voxels[x][y][z] == NULL &&
    voxels[x+1][y][z] != NULL &&
    voxels[x+1][y+1][z] == NULL &&
    voxels[x][y+1][z] == NULL &&
    voxels[x][y][z+1] != NULL &&
    voxels[x+1][y][z+1] != NULL &&
    voxels[x+1][y+1][z+1] == NULL &&
    voxels[x][y+1][z+1] == NULL;
}

bool MarchingCubes::cubeState34(short& x, short& y, short& z)
{
  return voxels[x][y][z] != NULL &&
    voxels[x+1][y][z] != NULL &&
    voxels[x+1][y+1][z] == NULL &&
    voxels[x][y+1][z] == NULL &&
    voxels[x][y][z+1] == NULL &&
    voxels[x+1][y][z+1] != NULL &&
    voxels[x+1][y+1][z+1] == NULL &&
    voxels[x][y+1][z+1] == NULL;
}

bool MarchingCubes::cubeState35(short& x, short& y, short& z)
{
  return voxels[x][y][z] != NULL &&
    voxels[x+1][y][z] != NULL &&
    voxels[x+1][y+1][z] == NULL &&
    voxels[x][y+1][z] == NULL &&
    voxels[x][y][z+1] != NULL &&
    voxels[x+1][y][z+1] == NULL &&
    voxels[x+1][y+1][z+1] == NULL &&
    voxels[x][y+1][z+1] == NULL;
}

bool MarchingCubes::cubeState36(short& x, short& y, short& z)
{
  return voxels[x][y][z] != NULL &&
    voxels[x+1][y][z] == NULL &&
    voxels[x+1][y+1][z] == NULL &&
    voxels[x][y+1][z] == NULL &&
    voxels[x][y][z+1] != NULL &&
    voxels[x+1][y][z+1] != NULL &&
    voxels[x+1][y+1][z+1] == NULL &&
    voxels[x][y+1][z+1] == NULL;
}

bool MarchingCubes::cubeState36_b(short& x, short& y, short& z)
{
  return voxels[x][y][z] == NULL &&
    voxels[x+1][y][z] == NULL &&
    voxels[x+1][y+1][z] != NULL &&
    voxels[x][y+1][z] == NULL &&
    voxels[x][y][z+1] == NULL &&
    voxels[x+1][y][z+1] == NULL &&
    voxels[x+1][y+1][z+1] != NULL &&
    voxels[x][y+1][z+1] != NULL;
}

bool MarchingCubes::cubeState37(short& x, short& y, short& z)
{
  return voxels[x][y][z] == NULL &&
    voxels[x+1][y][z] == NULL &&
    voxels[x+1][y+1][z] != NULL &&
    voxels[x][y+1][z] != NULL &&
    voxels[x][y][z+1] == NULL &&
    voxels[x+1][y][z+1] == NULL &&
    voxels[x+1][y+1][z+1] != NULL &&
    voxels[x][y+1][z+1] == NULL;
}

bool MarchingCubes::cubeState38(short& x, short& y, short& z)
{
  return voxels[x][y][z] == NULL &&
    voxels[x+1][y][z] == NULL &&
    voxels[x+1][y+1][z] != NULL &&
    voxels[x][y+1][z] != NULL &&
    voxels[x][y][z+1] == NULL &&
    voxels[x+1][y][z+1] == NULL &&
    voxels[x+1][y+1][z+1] == NULL &&
    voxels[x][y+1][z+1] != NULL;
}

bool MarchingCubes::cubeState39(short& x, short& y, short& z)
{
  return voxels[x][y][z] == NULL &&
    voxels[x+1][y][z] == NULL &&
    voxels[x+1][y+1][z] == NULL &&
    voxels[x][y+1][z] != NULL &&
    voxels[x][y][z+1] == NULL &&
    voxels[x+1][y][z+1] == NULL &&
    voxels[x+1][y+1][z+1] != NULL &&
    voxels[x][y+1][z+1] != NULL;
}

bool MarchingCubes::cubeState39_b(short& x, short& y, short& z)
{
  return voxels[x][y][z] == NULL &&
    voxels[x+1][y][z] != NULL &&
    voxels[x+1][y+1][z] == NULL &&
    voxels[x][y+1][z] == NULL &&
    voxels[x][y][z+1] == NULL &&
    voxels[x+1][y][z+1] != NULL &&
    voxels[x+1][y+1][z+1] != NULL &&
    voxels[x][y+1][z+1] == NULL;
}

bool MarchingCubes::cubeState40(short& x, short& y, short& z)
{
  return voxels[x][y][z] == NULL &&
    voxels[x+1][y][z] != NULL &&
    voxels[x+1][y+1][z] != NULL &&
    voxels[x][y+1][z] == NULL &&
    voxels[x][y][z+1] == NULL &&
    voxels[x+1][y][z+1] != NULL &&
    voxels[x+1][y+1][z+1] == NULL &&
    voxels[x][y+1][z+1] == NULL;
}

bool MarchingCubes::cubeState41(short& x, short& y, short& z)
{
  return voxels[x][y][z] == NULL &&
    voxels[x+1][y][z] == NULL &&
    voxels[x+1][y+1][z] != NULL &&
    voxels[x][y+1][z] == NULL &&
    voxels[x][y][z+1] == NULL &&
    voxels[x+1][y][z+1] != NULL &&
    voxels[x+1][y+1][z+1] != NULL &&
    voxels[x][y+1][z+1] == NULL;
}

bool MarchingCubes::cubeState42(short& x, short& y, short& z)
{
  return voxels[x][y][z] == NULL &&
    voxels[x+1][y][z] != NULL &&
    voxels[x+1][y+1][z] != NULL &&
    voxels[x][y+1][z] == NULL &&
    voxels[x][y][z+1] == NULL &&
    voxels[x+1][y][z+1] == NULL &&
    voxels[x+1][y+1][z+1] != NULL &&
    voxels[x][y+1][z+1] == NULL;
}

bool MarchingCubes::cubeState42_b(short& x, short& y, short& z)
{
  return voxels[x][y][z] != NULL &&
    voxels[x+1][y][z] == NULL &&
    voxels[x+1][y+1][z] == NULL &&
    voxels[x][y+1][z] == NULL &&
    voxels[x][y][z+1] != NULL &&
    voxels[x+1][y][z+1] == NULL &&
    voxels[x+1][y+1][z+1] == NULL &&
    voxels[x][y+1][z+1] != NULL;
}

bool MarchingCubes::cubeState43(short& x, short& y, short& z)
{
  return voxels[x][y][z] != NULL &&
    voxels[x+1][y][z] == NULL &&
    voxels[x+1][y+1][z] == NULL &&
    voxels[x][y+1][z] != NULL &&
    voxels[x][y][z+1] != NULL &&
    voxels[x+1][y][z+1] == NULL &&
    voxels[x+1][y+1][z+1] == NULL &&
    voxels[x][y+1][z+1] == NULL;
}

bool MarchingCubes::cubeState44(short& x, short& y, short& z)
{
  return voxels[x][y][z] == NULL &&
    voxels[x+1][y][z] == NULL &&
    voxels[x+1][y+1][z] == NULL &&
    voxels[x][y+1][z] != NULL &&
    voxels[x][y][z+1] != NULL &&
    voxels[x+1][y][z+1] == NULL &&
    voxels[x+1][y+1][z+1] == NULL &&
    voxels[x][y+1][z+1] != NULL;
}

bool MarchingCubes::cubeState45(short& x, short& y, short& z)
{
  return voxels[x][y][z] != NULL &&
    voxels[x+1][y][z] == NULL &&
    voxels[x+1][y+1][z] == NULL &&
    voxels[x][y+1][z] != NULL &&
    voxels[x][y][z+1] == NULL &&
    voxels[x+1][y][z+1] == NULL &&
    voxels[x+1][y+1][z+1] == NULL &&
    voxels[x][y+1][z+1] != NULL;
}

bool MarchingCubes::cubeState45_b(short& x, short& y, short& z)
{
  return voxels[x][y][z] != NULL &&
    voxels[x+1][y][z] != NULL &&
    voxels[x+1][y+1][z] != NULL &&
    voxels[x][y+1][z] == NULL &&
    voxels[x][y][z+1] == NULL &&
    voxels[x+1][y][z+1] == NULL &&
    voxels[x+1][y+1][z+1] == NULL &&
    voxels[x][y+1][z+1] == NULL;
}

bool MarchingCubes::cubeState46(short& x, short& y, short& z)
{
  return voxels[x][y][z] != NULL &&
    voxels[x+1][y][z] != NULL &&
    voxels[x+1][y+1][z] == NULL &&
    voxels[x][y+1][z] != NULL &&
    voxels[x][y][z+1] == NULL &&
    voxels[x+1][y][z+1] == NULL &&
    voxels[x+1][y+1][z+1] == NULL &&
    voxels[x][y+1][z+1] == NULL;
}

bool MarchingCubes::cubeState47(short& x, short& y, short& z)
{
  return voxels[x][y][z] == NULL &&
    voxels[x+1][y][z] != NULL &&
    voxels[x+1][y+1][z] != NULL &&
    voxels[x][y+1][z] != NULL &&
    voxels[x][y][z+1] == NULL &&
    voxels[x+1][y][z+1] == NULL &&
    voxels[x+1][y+1][z+1] == NULL &&
    voxels[x][y+1][z+1] == NULL;
}

bool MarchingCubes::cubeState48(short& x, short& y, short& z)
{
  return voxels[x][y][z] != NULL &&
    voxels[x+1][y][z] == NULL &&
    voxels[x+1][y+1][z] != NULL &&
    voxels[x][y+1][z] != NULL &&
    voxels[x][y][z+1] == NULL &&
    voxels[x+1][y][z+1] == NULL &&
    voxels[x+1][y+1][z+1] == NULL &&
    voxels[x][y+1][z+1] == NULL;
}

bool MarchingCubes::cubeState48_b(short& x, short& y, short& z)
{
  return voxels[x][y][z] == NULL &&
    voxels[x+1][y][z] == NULL &&
    voxels[x+1][y+1][z] == NULL &&
    voxels[x][y+1][z] == NULL &&
    voxels[x][y][z+1] != NULL &&
    voxels[x+1][y][z+1] != NULL &&
    voxels[x+1][y+1][z+1] != NULL &&
    voxels[x][y+1][z+1] == NULL;
}

bool MarchingCubes::cubeState49(short& x, short& y, short& z)
{
  return voxels[x][y][z] == NULL &&
    voxels[x+1][y][z] == NULL &&
    voxels[x+1][y+1][z] == NULL &&
    voxels[x][y+1][z] == NULL &&
    voxels[x][y][z+1] != NULL &&
    voxels[x+1][y][z+1] != NULL &&
    voxels[x+1][y+1][z+1] == NULL &&
    voxels[x][y+1][z+1] != NULL;
}

bool MarchingCubes::cubeState50(short& x, short& y, short& z)
{
  return voxels[x][y][z] == NULL &&
    voxels[x+1][y][z] == NULL &&
    voxels[x+1][y+1][z] == NULL &&
    voxels[x][y+1][z] == NULL &&
    voxels[x][y][z+1] == NULL &&
    voxels[x+1][y][z+1] != NULL &&
    voxels[x+1][y+1][z+1] != NULL &&
    voxels[x][y+1][z+1] != NULL;
}

bool MarchingCubes::cubeState50_b(short& x, short& y, short& z)
{
  return voxels[x][y][z] == NULL &&
    voxels[x+1][y][z] == NULL &&
    voxels[x+1][y+1][z] == NULL &&
    voxels[x][y+1][z] == NULL &&
    voxels[x][y][z+1] != NULL &&
    voxels[x+1][y][z+1] == NULL &&
    voxels[x+1][y+1][z+1] != NULL &&
    voxels[x][y+1][z+1] != NULL;
}

// configuration 6 starts here
bool MarchingCubes::cubeState51(short& x, short& y, short& z)
{
  return voxels[x][y][z] != NULL &&
    voxels[x+1][y][z] != NULL &&
    voxels[x+1][y+1][z] != NULL &&
    voxels[x][y+1][z] != NULL &&
    voxels[x][y][z+1] == NULL &&
    voxels[x+1][y][z+1] == NULL &&
    voxels[x+1][y+1][z+1] == NULL &&
    voxels[x][y+1][z+1] == NULL;
}

bool MarchingCubes::cubeState52(short& x, short& y, short& z)
{
  return voxels[x][y][z] == NULL &&
    voxels[x+1][y][z] == NULL &&
    voxels[x+1][y+1][z] == NULL &&
    voxels[x][y+1][z] == NULL &&
    voxels[x][y][z+1] != NULL &&
    voxels[x+1][y][z+1] != NULL &&
    voxels[x+1][y+1][z+1] != NULL &&
    voxels[x][y+1][z+1] != NULL;
}

bool MarchingCubes::cubeState53(short& x, short& y, short& z)
{
  return voxels[x][y][z] == NULL &&
    voxels[x+1][y][z] != NULL &&
    voxels[x+1][y+1][z] != NULL &&
    voxels[x][y+1][z] == NULL &&
    voxels[x][y][z+1] == NULL &&
    voxels[x+1][y][z+1] != NULL &&
    voxels[x+1][y+1][z+1] != NULL &&
    voxels[x][y+1][z+1] == NULL;
}

bool MarchingCubes::cubeState54(short& x, short& y, short& z)
{
  return voxels[x][y][z] != NULL &&
    voxels[x+1][y][z] == NULL &&
    voxels[x+1][y+1][z] == NULL &&
    voxels[x][y+1][z] != NULL &&
    voxels[x][y][z+1] != NULL &&
    voxels[x+1][y][z+1] == NULL &&
    voxels[x+1][y+1][z+1] == NULL &&
    voxels[x][y+1][z+1] != NULL;
}

bool MarchingCubes::cubeState55(short& x, short& y, short& z)
{
  return voxels[x][y][z] != NULL &&
    voxels[x+1][y][z] != NULL &&
    voxels[x+1][y+1][z] == NULL &&
    voxels[x][y+1][z] == NULL &&
    voxels[x][y][z+1] != NULL &&
    voxels[x+1][y][z+1] != NULL &&
    voxels[x+1][y+1][z+1] == NULL &&
    voxels[x][y+1][z+1] == NULL;
}

bool MarchingCubes::cubeState56(short& x, short& y, short& z)
{
  return voxels[x][y][z] == NULL &&
    voxels[x+1][y][z] == NULL &&
    voxels[x+1][y+1][z] != NULL &&
    voxels[x][y+1][z] != NULL &&
    voxels[x][y][z+1] == NULL &&
    voxels[x+1][y][z+1] == NULL &&
    voxels[x+1][y+1][z+1] != NULL &&
    voxels[x][y+1][z+1] != NULL;
}

bool MarchingCubes::cubeStateFull(short& x, short& y, short& z)
{
  return voxels[x][y][z] != NULL &&
    voxels[x+1][y][z] != NULL &&
    voxels[x+1][y+1][z] != NULL &&
    voxels[x][y+1][z] != NULL &&
    voxels[x][y][z+1] != NULL &&
    voxels[x+1][y][z+1] != NULL &&
    voxels[x+1][y+1][z+1] != NULL &&
    voxels[x][y+1][z+1] != NULL;
}

// Marching cube has 2x2x2 sub-cubes totalling 27 vertices
vector<float> MarchingCubes::getMarchingCubePoint(short pNum, short& x, short& y, short& z)
{
  vector<float> resVec;

  float voxDim = voxels[x][y][z]->getDim();
  float startX = (float)x * voxDim;
  float startY = (float)y * voxDim;
  float startZ = (float)z * -voxDim;

  if (pNum == 1) {
    resVec.push_back(startX);
    resVec.push_back(startY);
    resVec.push_back(startZ);
    return resVec;
  } else if (pNum == 2) {
    resVec.push_back(startX+voxDim);
    resVec.push_back(startY);
    resVec.push_back(startZ);
    return resVec;
  } else if (pNum == 3) {
    resVec.push_back(startX+(voxDim*2.0f));
    resVec.push_back(startY);
    resVec.push_back(startZ);
    return resVec;
  } else if (pNum == 4) {
    resVec.push_back(startX);
    resVec.push_back(startY+voxDim);
    resVec.push_back(startZ);
    return resVec;
  } else if (pNum == 5) {
    resVec.push_back(startX+voxDim);
    resVec.push_back(startY+voxDim);
    resVec.push_back(startZ);
    return resVec;
  } else if (pNum == 6) {
    resVec.push_back(startX+(voxDim*2.0f));
    resVec.push_back(startY+voxDim);
    resVec.push_back(startZ);
    return resVec;
  } else if (pNum == 7) {
    resVec.push_back(startX);
    resVec.push_back(startY+(voxDim*2.0f));
    resVec.push_back(startZ);
    return resVec;
  } else if (pNum == 8) {
    resVec.push_back(startX+voxDim);
    resVec.push_back(startY+(voxDim*2.0f));
    resVec.push_back(startZ);
    return resVec;
  } else if (pNum == 9) {
    resVec.push_back(startX+(voxDim*2.0f));
    resVec.push_back(startY+(voxDim*2.0f));
    resVec.push_back(startZ);
    return resVec;
  } else if (pNum ==10) {
    resVec.push_back(startX);
    resVec.push_back(startY);
    resVec.push_back(startZ-voxDim);
    return resVec;
  } else if (pNum == 11) {
    resVec.push_back(startX+voxDim);
    resVec.push_back(startY);
    resVec.push_back(startZ-voxDim);
    return resVec;
  } else if (pNum == 12) {
    resVec.push_back(startX+(voxDim*2.0f));
    resVec.push_back(startY);
    resVec.push_back(startZ-voxDim);
    return resVec;
  } else if (pNum == 13) {
    resVec.push_back(startX);
    resVec.push_back(startY+voxDim);
    resVec.push_back(startZ-voxDim);
    return resVec;
  } else if (pNum == 14) {
    resVec.push_back(startX+voxDim);
    resVec.push_back(startY+voxDim);
    resVec.push_back(startZ-voxDim);
    return resVec;
  } else if (pNum == 15) {
    resVec.push_back(startX+(voxDim*2.0f));
    resVec.push_back(startY+voxDim);
    resVec.push_back(startZ-voxDim);
    return resVec;
  } else if (pNum == 16) {
    resVec.push_back(startX);
    resVec.push_back(startY+(voxDim*2.0f));
    resVec.push_back(startZ-voxDim);
    return resVec;
  } else if (pNum == 17) {
    resVec.push_back(startX+voxDim);
    resVec.push_back(startY+(voxDim*2.0f));
    resVec.push_back(startZ-voxDim);
    return resVec;
  } else if (pNum == 18) {
    resVec.push_back(startX+(voxDim*2.0f));
    resVec.push_back(startY+(voxDim*2.0f));
    resVec.push_back(startZ-voxDim);
    return resVec;
  } else if (pNum == 19) {
    resVec.push_back(startX);
    resVec.push_back(startY);
    resVec.push_back(startZ-(voxDim*2.0f));
    return resVec;
  } else if (pNum == 20) {
    resVec.push_back(startX+voxDim);
    resVec.push_back(startY);
    resVec.push_back(startZ-(voxDim*2.0f));
    return resVec;
  } else if (pNum == 21) {
    resVec.push_back(startX+(voxDim*2.0f));
    resVec.push_back(startY);
    resVec.push_back(startZ-(voxDim*2.0f));
    return resVec;
  } else if (pNum == 22) {
    resVec.push_back(startX);
    resVec.push_back(startY+voxDim);
    resVec.push_back(startZ-(voxDim*2.0f));
    return resVec;
  } else if (pNum == 23) {
    resVec.push_back(startX+voxDim);
    resVec.push_back(startY+voxDim);
    resVec.push_back(startZ-(voxDim*2.0f));
    return resVec;
  } else if (pNum == 24) {
    resVec.push_back(startX+(voxDim*2.0f));
    resVec.push_back(startY+voxDim);
    resVec.push_back(startZ-(voxDim*2.0f));
    return resVec;
  } else if (pNum == 25) {
    resVec.push_back(startX);
    resVec.push_back(startY+(voxDim*2.0f));
    resVec.push_back(startZ-(voxDim*2.0f));
    return resVec;
  } else if (pNum == 26) {
    resVec.push_back(startX+voxDim);
    resVec.push_back(startY+(voxDim*2.0f));
    resVec.push_back(startZ-(voxDim*2.0f));
    return resVec;
  } else if (pNum == 27) {
    resVec.push_back(startX+(voxDim*2.0f));
    resVec.push_back(startY+(voxDim*2.0f));
    resVec.push_back(startZ-(voxDim*2.0f));
    return resVec;
  } else {
    cout << "Invalid point number!\n";
    exit(1);
  }
}

void MarchingCubes::addMeshTriangle(short pt1, short pt2, short pt3, short& x, short& y, short& z)
{
  vector<float> p1 = getMarchingCubePoint(pt1, x, y, z);
  vector<float> p2 = getMarchingCubePoint(pt2, x, y, z);
  vector<float> p3 = getMarchingCubePoint(pt3, x, y, z);
  mesh.push_back(new Triangle(
                              p1.at(0), p1.at(1), p1.at(2),
                              p2.at(0), p2.at(1), p2.at(2),
                              p3.at(0), p3.at(1), p3.at(2)));
}

//           ____________
//         / 8   / 7  / |
//       /_____/____/   |
//     /     /     / | /|
//    /_____/_____/  |/ |
//   | 4   | 3    | /|6/
//   |_____|______|/ |/
//   | 1   | 2    | /
//   |_____|______|/

void MarchingCubes::marchingCubes()
{
  //ftime(&start_time); // function timing
  for (short x = 0; x < GRID_SIZE-1; ++x) { // < GRID_SIZE-1, since scanning 2x2x2 voxels each step
    for (short y = 0; y < GRID_SIZE-1; ++y) {
      for (short z = 0; z < GRID_SIZE-1; ++z) {
        if (cubeState0(x, y, z)) {} // do nothing (important to test for the most common cases first, if match found, skip the rest).
        else if (cubeStateFull(x, y, z)) {} // do nothing
        else if (cubeState1(x, y, z)) { // configuration 2 starts here
          addMeshTriangle(10, 4, 2, x, y, z); // 1
        } else if (cubeState2(x, y, z)) {
          addMeshTriangle(2, 6, 12, x, y, z); // 2
        } else if (cubeState3(x, y, z)) {
          addMeshTriangle(8, 18, 6, x, y, z); // 3
        } else if (cubeState4(x, y, z)) {
          addMeshTriangle(4, 16, 8, x, y, z); // 4
        } else if (cubeState5(x, y, z)) {
          addMeshTriangle(10, 20, 22, x, y, z); // 5
        } else if (cubeState6(x, y, z)) {
          addMeshTriangle(12, 24, 20, x, y, z); // 6
        } else if (cubeState7(x, y, z)) {
          addMeshTriangle(24, 18, 26, x, y, z); // 7
        } else if (cubeState8(x, y, z)) {
          addMeshTriangle(22, 26, 16, x, y, z); // 8
        } else if (cubeState9(x, y, z)) { // configuration 3 starts here
          addMeshTriangle(12, 10, 4, x, y, z);
          addMeshTriangle(12, 4, 6, x, y, z);
        } else if (cubeState10(x, y, z)) {
          addMeshTriangle(6, 4, 16, x, y, z);
          addMeshTriangle(6, 16, 18, x, y, z);
        } else if (cubeState11(x, y, z)) {
          addMeshTriangle(10, 12, 24, x, y, z);
          addMeshTriangle(10, 24, 22, x, y, z);
        } else if (cubeState12(x, y, z)) {
          addMeshTriangle(22, 24, 16, x, y, z);
          addMeshTriangle(16, 24, 18, x, y, z);
        } else if (cubeState13(x, y, z)) {
          addMeshTriangle(2, 20, 4, x, y, z);
          addMeshTriangle(20, 22, 4, x, y, z);
        } else if (cubeState14(x, y, z)) {
          addMeshTriangle(20, 2, 6, x, y, z);
          addMeshTriangle(20, 6, 24, x, y, z);
        } else if (cubeState15(x, y, z)) {
          addMeshTriangle(24, 6, 8, x, y, z);
          addMeshTriangle(8, 26, 24, x, y, z);
        } else if (cubeState16(x, y, z)) {
          addMeshTriangle(4, 22, 26, x, y, z);
          addMeshTriangle(26, 8, 4, x, y, z);
        } else if (cubeState17(x, y, z)) {
          addMeshTriangle(2, 10, 16, x, y, z);
          addMeshTriangle(16, 8, 2, x, y, z);
        } else if (cubeState18(x, y, z)) {
          addMeshTriangle(2, 8, 18, x, y, z);
          addMeshTriangle(18, 12, 2, x, y, z);
        } else if (cubeState19(x, y, z)) {
          addMeshTriangle(12, 18, 20, x, y, z);
          addMeshTriangle(20, 18, 26, x, y, z);
        } else if (cubeState20(x, y, z)) {
          addMeshTriangle(16, 10, 20, x, y, z);
          addMeshTriangle(20, 26, 16, x, y, z);
        } else if (cubeState21(x, y, z)) { // configuration 4 starts here
          addMeshTriangle(2, 4, 10, x, y, z);
          addMeshTriangle(5, 9, 15, x, y, z);
        } else if (cubeState22(x, y, z)) {
          addMeshTriangle(2, 6, 12, x, y, z);
          addMeshTriangle(5, 13, 16, x, y, z);
        } else if (cubeState23(x, y, z)) {
          addMeshTriangle(2, 6, 12, x, y, z);
          addMeshTriangle(15, 27, 23, x, y, z);
        } else if (cubeState24(x, y, z)) {
          addMeshTriangle(5, 9, 15, x, y, z);
          addMeshTriangle(12, 24, 20, x, y, z);
        } else if (cubeState25(x, y, z)) {
          addMeshTriangle(10, 20, 22, x, y, z);
          addMeshTriangle(15, 27, 23, x, y, z);
        } else if (cubeState26(x, y, z)) {
          addMeshTriangle(12, 24, 20, x, y, z);
          addMeshTriangle(13, 23, 25, x, y, z);
        } else if (cubeState27(x, y, z)) {
          addMeshTriangle(5, 13, 16, x, y, z);
          addMeshTriangle(10, 20, 22, x, y, z);
        } else if (cubeState28(x, y, z)) {
          addMeshTriangle(2, 4, 10, x, y, z);
          addMeshTriangle(13, 23, 25, x, y, z);
        } else if (cubeState29(x, y, z)) {
          addMeshTriangle(5, 13, 16, x, y, z);
          addMeshTriangle(15, 27, 23, x, y, z);
        } else if (cubeState30(x, y, z)) {
          addMeshTriangle(5, 9, 15, x, y, z);
          addMeshTriangle(13, 23, 25, x, y, z);
        } else if (cubeState31(x, y, z)) {
          addMeshTriangle(2, 4, 10, x, y, z);
          addMeshTriangle(12, 24, 20, x, y, z);
        } else if (cubeState32(x, y, z)) {
          addMeshTriangle(2, 6, 12, x, y, z);
          addMeshTriangle(10, 20, 22, x, y, z);
        } else if (cubeState33(x, y, z)) { // configuration 5 starts here
          addMeshTriangle(24, 22, 6, x, y, z);
          addMeshTriangle(10, 2, 6, x, y, z);
          addMeshTriangle(6, 22, 10, x, y, z);
        } else if  (cubeState34(x, y, z)) {
          addMeshTriangle(6, 24, 4, x, y, z);
          addMeshTriangle(20, 10, 4, x, y, z);
          addMeshTriangle(4, 24, 20, x, y, z);
        } else if (cubeState35(x, y, z)) {
          addMeshTriangle(4, 6, 22, x, y, z);
          addMeshTriangle(6, 12, 20, x, y, z);
          addMeshTriangle(20, 22, 6, x, y, z);
        } else if (cubeState36(x, y, z)) {
          addMeshTriangle(22, 4, 24, x, y, z);
          addMeshTriangle(4, 2, 12, x, y, z);
          addMeshTriangle(12, 24, 4, x, y ,z);
        } else if (cubeState36_b(x, y, z)) {
          addMeshTriangle(24, 6, 22, x, y, z);
          addMeshTriangle(6, 8, 16, x, y, z);
          addMeshTriangle(16, 22, 6, x, y, z);
        } else if (cubeState37(x, y, z)) {
          addMeshTriangle(6, 4, 24, x, y, z);
          addMeshTriangle(4, 16, 26, x, y, z);
          addMeshTriangle(26, 24, 4, x, y, z);
        } else if (cubeState38(x, y, z)) {
          addMeshTriangle(4, 22, 6, x, y, z);
          addMeshTriangle(22, 26, 18, x, y, z);
          addMeshTriangle(18, 6, 22, x, y, z);
        } else if (cubeState39(x, y, z)) {
          addMeshTriangle(22, 24, 4, x, y, z);
          addMeshTriangle(24, 18, 8, x, y, z);
          addMeshTriangle(8, 4, 24, x, y, z);
        } else if (cubeState39_b(x, y, z)) {
          addMeshTriangle(20, 2, 26, x, y, z);
          addMeshTriangle(2, 6, 18, x, y, z);
          addMeshTriangle(18, 26, 2, x, y, z);
        } else if (cubeState40(x, y, z)) {
          addMeshTriangle(2, 8, 20, x, y, z);
          addMeshTriangle(8, 18, 26, x, y, z);
          addMeshTriangle(26, 20, 8, x, y, z);
        } else if (cubeState41(x, y, z)) {
          addMeshTriangle(26, 20, 8, x, y, z);
          addMeshTriangle(20, 12, 6, x, y, z);
          addMeshTriangle(6, 8, 20, x, y, z);
        } else if (cubeState42(x, y, z)) {
          addMeshTriangle(8, 26, 2, x, y, z);
          addMeshTriangle(26, 24, 12, x, y, z);
          addMeshTriangle(12, 2, 26, x, y, z);
        } else if (cubeState42_b(x, y, z)) {
          addMeshTriangle(2, 26, 8, x, y, z);
          addMeshTriangle(12, 24, 26, x, y, z);
          addMeshTriangle(26, 2, 12, x, y, z);
        } else if (cubeState43(x, y, z)) {
          addMeshTriangle(20, 8, 2, x, y, z);
          addMeshTriangle(23, 16, 8, x, y, z);
          addMeshTriangle(8, 20, 23, x, y, z);
        } else if (cubeState44(x, y, z)) {
          addMeshTriangle(26, 8, 20, x, y, z);
          addMeshTriangle(8, 4, 10, x, y, z);
          addMeshTriangle(10, 20, 8, x, y, z);
        } else if (cubeState45(x, y, z)) {
          addMeshTriangle(8, 2, 26, x, y, z);
          addMeshTriangle(2, 10, 20, x, y, z);
          addMeshTriangle(20, 26, 2, x, y, z);
        } else if (cubeState45_b(x, y, z)) {
          addMeshTriangle(12, 10, 18, x, y, z);
          addMeshTriangle(10, 4, 8, x, y, z);
          addMeshTriangle(8, 18, 10, x, y, z);
        } else if (cubeState46(x, y, z)) {
          addMeshTriangle(10, 16, 12, x, y, z);
          addMeshTriangle(16, 8, 6, x, y, z);
          addMeshTriangle(6, 12, 16, x, y, z);
        } else if (cubeState47(x, y, z)) {
          addMeshTriangle(18, 12, 16, x, y, z);
          addMeshTriangle(12, 2, 4, x, y, z);
          addMeshTriangle(4, 16, 12, x, y, z);
        } else if (cubeState48(x, y, z)) {
          addMeshTriangle(16, 18, 10, x, y, z);
          addMeshTriangle(18, 6, 2, x, y, z);
          addMeshTriangle(2, 10, 18, x, y, z);
        } else if (cubeState48_b(x, y, z)) {
          addMeshTriangle(18, 10, 12, x, y, z);
          addMeshTriangle(26, 22, 10, x, y, z);
          addMeshTriangle(10, 18, 26, x, y, z);
        } else if (cubeState49(x, y, z)) {
          addMeshTriangle(12, 16, 10, x, y, z);
          addMeshTriangle(12, 24, 26, x, y, z);
          addMeshTriangle(26, 16, 12, x, y, z);
        } else if (cubeState50(x, y, z)) {
          addMeshTriangle(16, 12, 18, x, y, z);
          addMeshTriangle(22, 20, 12, x, y, z);
          addMeshTriangle(12, 16, 22, x, y, z);
        } else if (cubeState50_b(x, y, z)) {
          addMeshTriangle(16, 10, 18, x, y, z);
          addMeshTriangle(10, 20, 24, x, y, z);
          addMeshTriangle(24, 18, 10, x, y, z);
        } else if (cubeState51(x, y, z)) { // configuration 6 starts here
          addMeshTriangle(16, 12, 10, x, y, z);
          addMeshTriangle(18, 12, 16, x, y, z);
        } else if (cubeState52(x, y, z)) {
          addMeshTriangle(10, 12, 16, x, y, z);
          addMeshTriangle(16, 12, 18, x, y, z);
        } else if (cubeState53(x, y, z)) {
          addMeshTriangle(20, 2, 8, x, y, z);
          addMeshTriangle(8, 26, 20, x, y, z);
        } else if (cubeState54(x, y, z)) {
          addMeshTriangle(8, 2, 20, x, y, z);
          addMeshTriangle(20, 26, 8, x, y, z);
        } else if (cubeState55(x, y, z)) {
          addMeshTriangle(22, 4, 6, x, y, z);
          addMeshTriangle(6, 24, 22, x, y, z);
        } else if (cubeState56(x, y, z)) {
          addMeshTriangle(6, 4, 22, x, y, z);
          addMeshTriangle(22, 24, 6, x, y, z);
        }
      }
    }
  }
  // calculate running time of function
  //ftime(&current_time);
  //ms_since_start = (long) (1000.0 * (current_time.time - start_time.time) + (current_time.millitm - start_time.millitm));
  //printf("ms since start: %d \n", ms_since_start);
  
}


