//Material.h

#ifndef GR_MATERIAL_H
#define GR_MATERIAL_H

class Material {

public:
  GLfloat ambient[4];
  GLfloat diffuse[4];
  GLfloat specular[4];
  GLfloat emission[4];
  GLfloat shininess;
  
  Material() {
    
  ambient[0] = 0.2; // R
  ambient[1] = 0.2; // G
  ambient[2] = 0.2; // B
  ambient[3] = 1.0; // A
    
  diffuse[0] = 0.5; // R
  diffuse[1] = 0.5; // G
  diffuse[2] = 0.5; // B
  diffuse[3] = 1.0; // A
    
  specular[0] = 0.5; // R
  specular[1] = 0.5; // G
  specular[2] = 0.5; // B
  specular[3] = 1.0; // A
    
  emission[0] = 0.03; // R
  emission[1] = 0.03; // G
  emission[2] = 0.03; // B
  emission[3] = 1.00; // A
    
  shininess = 60.0;
    
  }
  
  Material(GLfloat* amb, GLfloat* dif, GLfloat* spec, GLfloat* em, GLfloat shi) {
    
    ambient[0] = amb[0]; // R
    ambient[1] = amb[1]; // G
    ambient[2] = amb[2]; // B
    ambient[3] = amb[3]; // A
    
    diffuse[0] = dif[0]; // R
    diffuse[1] = dif[1]; // G
    diffuse[2] = dif[2]; // B
    diffuse[3] = dif[3]; // A
    
    specular[0] = spec[0]; // R
    specular[1] = spec[1]; // G
    specular[2] = spec[2]; // B
    specular[3] = spec[3]; // A
    
    emission[0] = em[0]; // R
    emission[1] = em[1]; // G
    emission[2] = em[2]; // B
    emission[3] = em[3]; // A
    
    shininess = shi;
  
  }
  
};

#endif // GR_MATERIAL_H
