// Models.h

#ifndef MODELS_H
#define MODELS_H

#include <vector>

using std::vector;

class Models
{
public:
  Models();
  ~Models();

  static void plotTestVoxels();
  static void plotNoise(int factor);
  static void plot3DFunc();
  static void plotSimpleModel1();
  static void plotSimpleModel2();
  static void plot2DFunc();
  static void plotSphere(float intensity = 0.9f, double scale = 0.5, short xTrans = 0,
                         short yTrans = 0, short zTrans = 0, int noise = 0);
  static void plotCube(float intensity = 0.9f, short scale = 0, short xTrans = 0,
                       short yTrans = 0, short zTrans = 0, int rotation = 0, int noise = 0);
  static void plotModelGroup1();
  static void plotModelGroup2();
  static void plotSegTest1();
  static void plotBiasTest();
  static void plotSRGTest1();
  static void plotSRGTest2();
  static void plotFIFOtest();
  static void plot3DGasket();
  static void plotGrid();
  static void plotGridWithBorder();
  static void plotBorg();
  static void plotBorder();
  
  static void initVoxelGrid();
  static void floodFillNull(float intensity);
  
  static void initSecVoxelGrid();
  static void booleanSubtract();
  static void plotSecSphere();
  
  static vector<short> createVoxelIndex(short x, short y, short z);
  static void setRenderVoxels(vector<vector<short> > renderVoxelIndexVector);
  static void updateRenderVoxels();
  static void plotVoxel(int x, int y, int z, float val);
  static void deleteVoxel(int x, int y, int z);
  static void deleteAllVoxels();

private:


};

#endif // MODELS_H
