// Triangle.cpp

#include "Triangle.h"
#include <cmath>
#include <iostream>

using std::cout;
using std::endl;

bool Triangle::wireframe = false;
//Material Triangle::material;


Triangle::Triangle(float v1, float v2, float v3,
                   float v4, float v5, float v6,
                   float v7, float v8, float v9)
{
  p1x = v1;
  p1y = v2;
  p1z = v3;
  p2x = v4;
  p2y = v5;
  p2z = v6;
  p3x = v7;
  p3y = v8;
  p3z = v9;
  GLfloat normal[3];
  GLfloat p1[3] = {p1x, p1y, p1z};
  GLfloat p2[3] = {p2x, p2y, p2z};
  GLfloat p3[3] = {p3x, p3y, p3z};
  cross(p1, p2, p3, normal);
  n1 = normal[0];
  n2 = normal[1];
  n3 = normal[2];
}

void Triangle::normalize(GLfloat* p)
{
  float d = 0.0;
  int i;
  for (i = 0; i < 3; i++) d += p[i]*p[i];
  d = sqrt(d);
  if (d > 0.0) for (i = 0; i < 3; i++) p[i] /= d;
}

void Triangle::cross(GLfloat* a, GLfloat* b, GLfloat* c, GLfloat* d)
{
  d[0] = (b[1]-a[1])*(c[2]-a[2])-(b[2]-a[2])*(c[1]-a[1]);
  d[1] = (b[2]-a[2])*(c[0]-a[0])-(b[0]-a[0])*(c[2]-a[2]);
  d[2] = (b[0]-a[0])*(c[1]-a[1])-(b[1]-a[1])*(c[0]-a[0]);
  normalize(d);
}

Triangle::~Triangle() {}

void Triangle::draw()
{
  glColor4f(0.1, 0.1, 0.1, 1.0);
  //glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
 
  //cout << n1 << n2 << n3 << endl;
  glBegin(GL_TRIANGLES);
  glNormal3f(n1, n2, n3);
  glVertex4f(p1x, p1y, p1z, 1.0f);
  glVertex4f(p2x, p2y, p2z, 1.0f);
  glVertex4f(p3x, p3y, p3z, 1.0f);
  glEnd();

   if (wireframe) {
    glColor4f(1.0, 1.0, 1.0, 1.0);
    glPolygonOffset(1.0, 1.0);
    glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
    glLineWidth(.01);
    glBegin(GL_TRIANGLES);
    glNormal3f(n1, n2, n3);
    glVertex4f(p1x, p1y, p1z, 1.0f);
    glVertex4f(p2x, p2y, p2z, 1.0f);
    glVertex4f(p3x, p3y, p3z, 1.0f);
    glEnd();
    glPolygonOffset(0.0, 0.0);
    glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
  }
}
