// Voxel.h

#ifndef VOXEL_H
#define VOXEL_H

struct VoxData
{
  unsigned int intensity:16;
  unsigned int label:16;
};

class Voxel
{
public:
  Voxel();
  Voxel(float value);
  Voxel(unsigned short value);
  ~Voxel();

  void draw(short& gridX, short& gridY, short& gridZ);
  void setIntensity(float fVal) { vox_data.intensity = floatToIntensity(fVal); }
  void setIntensity(unsigned short val) { vox_data.intensity = val; }
  void setLabel(unsigned short val) { vox_data.label = val; }
  float getIntensity() { return intensityToFloat(); }
  unsigned short getIntensityShort() { return vox_data.intensity; }
  unsigned short getLabel() { return vox_data.label; }
  unsigned short floatToIntensity(float fVal);
  float intensityToFloat();

  static float getDim() { return dim; }

  static void togglePseudoColor() {
    if (pseudoColor) pseudoColor = false;
    else pseudoColor = true;
  }
  static void toggleWireframe() { 
    if (wireframe) wireframe = false;
    else wireframe = true;
  }
  static void togglePoint() {
    if (point) point = false;
    else point = true;
  }
  
private:
  struct VoxData vox_data;
  static float alpha;
  static float dim;
  static bool pseudoColor;
  static bool wireframe;
  static bool point;
  static const float MAX_VAL;
  
} /*__attribute__((__packed__))*/;

#endif // VOXEL_H
